const FILESYSTEMS = [
    [
        { filename: 'Fotos', data: [
            { filename: 'foto01.jpg', data: 'foto01', type: 'image/jpeg' },
            { filename: 'foto02.jpg', data: 'foto02', type: 'image/jpeg' },
            { filename: 'foto03.jpg', data: 'foto03', type: 'image/jpeg' },
            { filename: 'foto04.jpg', data: 'foto04', type: 'image/jpeg' },
            { filename: 'foto05.jpg', data: 'foto05', type: 'image/jpeg' },
            { filename: 'foto06.jpg', data: 'foto06', type: 'image/jpeg' },
            { filename: 'foto07.jpg', data: 'foto07', type: 'image/jpeg' },
            { filename: 'foto08.jpg', data: 'foto08', type: 'image/jpeg' },
            { filename: 'foto09.jpg', data: 'foto09', type: 'image/jpeg' },
            { filename: 'foto10.jpg', data: 'foto10', type: 'image/jpeg' },
            { filename: 'foto11.jpg', data: 'foto11', type: 'image/jpeg' }
        ] },
        { filename: 'Referat', data: [
            { filename: 'Praesentation.odp', data: '', type: 'application/vnd.oasis.opendocument.presentation' },
            { filename: 'Handout.odt', data: '', type: 'application/vnd.oasis.opendocument.text' },
            { filename: 'Handout.pdf', data: '', type: 'application/pdf' },
            { filename: 'backup', data: [
                { filename: 'Videos', data: [
                    { filename: 'trailer1.mp4', data: 'trailer1', type: 'video/mp4' },
                    { filename: 'trailer2.mp4', data: 'trailer2', type: 'video/mp4' },
                    { filename: 'teaser.mp4', data: 'teaser', type: 'video/mp4' },
                    { filename: 'Filmkritik.ogv', data: 'trailer1', type: 'video/ogg' },
                    { filename: 'Quelle', data: [
                        { filename: 'index.html', data: 'index', type: 'text/html' },
                        { filename: 'main.css', data: 'main', type: 'text/css' },
                        { filename: 'logo.svg', data: 'logo', type: 'image/svg+xml' },
                        { filename: 'spites.svg', data: 'spites', type: 'image/svg+xml' }
                    ] }
                ] }
            ] }
        ] },
        { filename: 'trailer3.mp4', data: 'trailer3', type: 'video/mp4' },
        { filename: 'Arbeitsauftrag.pdf', data: 'Arbeitsauftrag', type: 'application/pdf' }
    ],
    [
        { filename: 'Fotos', data: [
            { filename: 'foto01.jpg', data: 'foto01', type: 'image/jpeg' },
            { filename: 'foto02.jpg', data: 'foto02', type: 'image/jpeg' },
            { filename: 'foto03.jpg', data: 'foto03', type: 'image/jpeg' },
            { filename: 'foto04.jpg', data: 'foto04', type: 'image/jpeg' },
            { filename: 'foto05.jpg', data: 'foto05', type: 'image/jpeg' },
            { filename: 'foto06.jpg', data: 'foto06', type: 'image/jpeg' },
            { filename: 'foto07.jpg', data: 'foto07', type: 'image/jpeg' },
            { filename: 'foto08.jpg', data: 'foto08', type: 'image/jpeg' },
            { filename: 'foto09.jpg', data: 'foto09', type: 'image/jpeg' },
            { filename: 'foto10.jpg', data: 'foto10', type: 'image/jpeg' },
            { filename: 'foto11.jpg', data: 'foto11', type: 'image/jpeg' }
        ] },
        { filename: 'Referat', data: [
            { filename: 'Praesentation.odp', data: '', type: 'application/vnd.oasis.opendocument.presentation' },
            { filename: 'Handout.odt', data: '', type: 'application/vnd.oasis.opendocument.text' },
            { filename: 'Handout.pdf', data: '', type: 'application/pdf' },
            { filename: 'backup', data: [] }
        ] },
        { filename: 'trailer3.mp4', data: 'trailer3', type: 'video/mp4' },
        { filename: 'Arbeitsauftrag.pdf', data: 'Arbeitsauftrag', type: 'application/pdf' },
        { filename: 'Videos', data: [
            { filename: 'trailer1.mp4', data: 'trailer1', type: 'video/mp4' },
            { filename: 'trailer2.mp4', data: 'trailer2', type: 'video/mp4' },
            { filename: 'teaser.mp4', data: 'teaser', type: 'video/mp4' },
            { filename: 'Filmkritik.ogv', data: 'trailer1', type: 'video/ogg' },
            { filename: 'Quelle', data: [
                { filename: 'index.html', data: 'index', type: 'text/html' },
                { filename: 'main.css', data: 'main', type: 'text/css' },
                { filename: 'logo.svg', data: 'logo', type: 'image/svg+xml' },
                { filename: 'spites.svg', data: 'spites', type: 'image/svg+xml' }
            ] }
        ] }
    ],
    [
        { filename: 'Fotos', data: [
            { filename: 'foto01.jpg', data: 'foto01', type: 'image/jpeg' },
            { filename: 'foto02.jpg', data: 'foto02', type: 'image/jpeg' },
            { filename: 'foto03.jpg', data: 'foto03', type: 'image/jpeg' },
            { filename: 'foto04.jpg', data: 'foto04', type: 'image/jpeg' },
            { filename: 'foto05.jpg', data: 'foto05', type: 'image/jpeg' },
            { filename: 'foto06.jpg', data: 'foto06', type: 'image/jpeg' },
            { filename: 'foto07.jpg', data: 'foto07', type: 'image/jpeg' },
            { filename: 'foto08.jpg', data: 'foto08', type: 'image/jpeg' },
            { filename: 'foto09.jpg', data: 'foto09', type: 'image/jpeg' },
            { filename: 'foto10.jpg', data: 'foto10', type: 'image/jpeg' },
            { filename: 'foto11.jpg', data: 'foto11', type: 'image/jpeg' }
        ] },
        { filename: 'Referat', data: [
            { filename: 'Praesentation.odp', data: 'Praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
            { filename: 'Handout.odt', data: 'Handout', type: 'application/vnd.oasis.opendocument.text' },
            { filename: 'Handout.pdf', data: 'Handout', type: 'application/pdf' },
            { filename: 'foto07.jpg', data: 'foto07', type: 'image/jpeg' },
            { filename: 'backup', data: [] }
        ] },
        { filename: 'trailer3.mp4', data: 'trailer3', type: 'video/mp4' },
        { filename: 'Arbeitsauftrag.pdf', data: 'Arbeitsauftrag', type: 'application/pdf' },
        { filename: 'Videos', data: [
            { filename: 'trailer1.mp4', data: 'trailer1', type: 'video/mp4' },
            { filename: 'trailer2.mp4', data: 'trailer2', type: 'video/mp4' },
            { filename: 'teaser.mp4', data: 'teaser', type: 'video/mp4' },
            { filename: 'Filmkritik.ogv', data: 'trailer1', type: 'video/ogg' },
            { filename: 'Quelle', data: [
                { filename: 'index.html', data: 'index', type: 'text/html' },
                { filename: 'main.css', data: 'main', type: 'text/css' },
                { filename: 'logo.svg', data: 'logo', type: 'image/svg+xml' },
                { filename: 'spites.svg', data: 'spites', type: 'image/svg+xml' }
            ] }
        ] }
    ],
    [
        { filename: 'Fotos', data: [
            { filename: 'foto01.jpg', data: 'foto01', type: 'image/jpeg' },
            { filename: 'foto02.jpg', data: 'foto02', type: 'image/jpeg' },
            { filename: 'foto03.jpg', data: 'foto03', type: 'image/jpeg' },
            { filename: 'foto04.jpg', data: 'foto04', type: 'image/jpeg' },
            { filename: 'foto05.jpg', data: 'foto05', type: 'image/jpeg' },
            { filename: 'foto06.jpg', data: 'foto06', type: 'image/jpeg' },
            { filename: 'foto07.jpg', data: 'foto07', type: 'image/jpeg' },
            { filename: 'foto08.jpg', data: 'foto08', type: 'image/jpeg' },
            { filename: 'foto09.jpg', data: 'foto09', type: 'image/jpeg' },
            { filename: 'foto10.jpg', data: 'foto10', type: 'image/jpeg' },
            { filename: 'foto11.jpg', data: 'foto11', type: 'image/jpeg' }
        ] },
        { filename: 'Referat', data: [
            { filename: 'Praesentation.odp', data: 'Praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
            { filename: 'Handout.odt', data: 'Handout', type: 'application/vnd.oasis.opendocument.text' },
            { filename: 'Handout.pdf', data: 'Handout', type: 'application/pdf' },
            { filename: 'foto07.jpg', data: 'foto07', type: 'image/jpeg' },
            { filename: 'backup', data: [
                { filename: 'Praesentation.odp', data: 'backup/Praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
                { filename: 'Handout.odt', data: 'backup/Handout', type: 'application/vnd.oasis.opendocument.text' },
                { filename: 'Handout.pdf', data: 'backup/Handout', type: 'application/pdf' },
                { filename: 'foto07.jpg', data: 'backup/foto07', type: 'image/jpeg' }
            ] }
        ] },
        { filename: 'trailer3.mp4', data: 'trailer3', type: 'video/mp4' },
        { filename: 'Arbeitsauftrag.pdf', data: 'Arbeitsauftrag', type: 'application/pdf' },
        { filename: 'Videos', data: [
            { filename: 'trailer1.mp4', data: 'trailer1', type: 'video/mp4' },
            { filename: 'trailer2.mp4', data: 'trailer2', type: 'video/mp4' },
            { filename: 'teaser.mp4', data: 'teaser', type: 'video/mp4' },
            { filename: 'Filmkritik.ogv', data: 'trailer1', type: 'video/ogg' },
            { filename: 'Quelle', data: [
                { filename: 'index.html', data: 'index', type: 'text/html' },
                { filename: 'main.css', data: 'main', type: 'text/css' },
                { filename: 'logo.svg', data: 'logo', type: 'image/svg+xml' },
                { filename: 'spites.svg', data: 'spites', type: 'image/svg+xml' }
            ] }
        ] }
    ],
    [
        { filename: 'Fotos', data: [
            { filename: 'foto01.jpg', data: 'foto01', type: 'image/jpeg' },
            { filename: 'foto02.jpg', data: 'foto02', type: 'image/jpeg' },
            { filename: 'foto03.jpg', data: 'foto03', type: 'image/jpeg' },
            { filename: 'foto04.jpg', data: 'foto04', type: 'image/jpeg' },
            { filename: 'foto05.jpg', data: 'foto05', type: 'image/jpeg' },
            { filename: 'foto06.jpg', data: 'foto06', type: 'image/jpeg' },
            { filename: 'foto07.jpg', data: 'foto07', type: 'image/jpeg' },
            { filename: 'foto08.jpg', data: 'foto08', type: 'image/jpeg' },
            { filename: 'foto09.jpg', data: 'foto09', type: 'image/jpeg' },
            { filename: 'foto10.jpg', data: 'foto10', type: 'image/jpeg' },
            { filename: 'foto11.jpg', data: 'foto11', type: 'image/jpeg' }
        ] },
        { filename: 'Referat', data: [
            { filename: 'Praesentation.odp', data: '', type: 'application/vnd.oasis.opendocument.presentation' },
            { filename: 'Handout.odt', data: '', type: 'application/vnd.oasis.opendocument.text' },
            { filename: 'Handout.pdf', data: '', type: 'application/pdf' },
            { filename: 'backup', data: [
                { filename: 'Videos', data: [
                    { filename: 'trailer1.mp4', data: 'trailer1', type: 'video/mp4' },
                    { filename: 'trailer2.mp4', data: 'trailer2', type: 'video/mp4' },
                    { filename: 'teaser.mp4', data: 'teaser', type: 'video/mp4' },
                    { filename: 'Filmkritik.ogv', data: 'trailer1', type: 'video/ogg' },
                    { filename: 'Quelle', data: [
                        { filename: 'index.html', data: 'index', type: 'text/html' },
                        { filename: 'main.css', data: 'main', type: 'text/css' },
                        { filename: 'logo.svg', data: 'logo', type: 'image/svg+xml' },
                        { filename: 'spites.svg', data: 'spites', type: 'image/svg+xml' }
                    ] }
                ] }
            ] }
        ] },
        { filename: 'trailer3.mp4', data: 'trailer3', type: 'video/mp4' },
        { filename: 'Arbeitsauftrag.pdf', data: 'Arbeitsauftrag', type: 'application/pdf' },
        { filename: '∞🙉 ↑', data: '' }
    ],
    [
        { filename: 'Fotos', data: [
            { filename: 'foto01.jpg', data: 'foto01', type: 'image/jpeg' },
            { filename: 'foto02.jpg', data: 'foto02', type: 'image/jpeg' },
            { filename: 'foto03.jpg', data: 'foto03', type: 'image/jpeg' },
            { filename: 'foto04.jpg', data: 'foto04', type: 'image/jpeg' },
            { filename: 'foto05.jpg', data: 'foto05', type: 'image/jpeg' },
            { filename: 'foto06.jpg', data: 'foto06', type: 'image/jpeg' },
            { filename: 'foto07.jpg', data: 'foto07', type: 'image/jpeg' },
            { filename: 'foto08.jpg', data: 'foto08', type: 'image/jpeg' },
            { filename: 'foto09.jpg', data: 'foto09', type: 'image/jpeg' },
            { filename: 'foto10.jpg', data: 'foto10', type: 'image/jpeg' },
            { filename: 'foto11.jpg', data: 'foto11', type: 'image/jpeg' }
        ] },
        { filename: 'Referat', data: [
            { filename: 'Praesentation.odp', data: 'Praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
            { filename: 'Handout.odt', data: 'Handout', type: 'application/vnd.oasis.opendocument.text' },
            { filename: 'Handout.pdf', data: 'Handout', type: 'application/pdf' },
            { filename: 'foto07.jpg', data: 'foto07', type: 'image/jpeg' },
            { filename: 'backup', data: [
                { filename: 'Praesentation.odp', data: 'backup/Praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
                { filename: 'Handout.odt', data: 'backup/Handout', type: 'application/vnd.oasis.opendocument.text' },
                { filename: 'Handout.pdf', data: 'backup/Handout', type: 'application/pdf' },
                { filename: 'foto07.jpg', data: 'backup/foto07', type: 'image/jpeg' }
            ] }
        ] },
        { filename: 'Arbeitsauftrag.pdf', data: 'Arbeitsauftrag', type: 'application/pdf' },
        { filename: 'Videos', data: [
            { filename: 'trailer1.mp4', data: 'trailer1', type: 'video/mp4' },
            { filename: 'trailer2.mp4', data: 'trailer2', type: 'video/mp4' },
            { filename: 'trailer3.mp4', data: 'trailer3', type: 'video/mp4' },
            { filename: 'teaser.mp4', data: 'teaser', type: 'video/mp4' },
            { filename: 'Filmkritik.ogv', data: 'trailer1', type: 'video/ogg' },
            { filename: 'Quelle', data: [
                { filename: 'index.html', data: 'index', type: 'text/html' },
                { filename: 'main.css', data: 'main', type: 'text/css' },
                { filename: 'logo.svg', data: 'logo', type: 'image/svg+xml' },
                { filename: 'spites.svg', data: 'spites', type: 'image/svg+xml' }
            ] }
        ] }
    ]
];

const LEVELS = [
    {
        environment: { clipboard: { move: true, path: '/Referat/backup/Videos' }, path: '/', files: FILESYSTEMS[0] },
        html: 'Füge den Inhalt der Zwischenablage im Wurzelordner ein.',
        onchange() {
            return !this.check([
                { path: '/Videos/trailer1.mp4', data: 'trailer1', type: 'video/mp4' },
                { path: '/Videos/trailer2.mp4', data: 'trailer2', type: 'video/mp4' },
                { path: '/Videos/teaser.mp4', data: 'teaser', type: 'video/mp4' },
                { path: '/Videos/Filmkritik.ogv', data: 'trailer1', type: 'video/ogg' },
                { path: '/Videos/Quelle' },
                { path: '/Videos/Quelle/index.html', data: 'index', type: 'text/html' },
                { path: '/Videos/Quelle/main.css', data: 'main', type: 'text/css' },
                { path: '/Videos/Quelle/logo.svg', data: 'logo', type: 'image/svg+xml' },
                { path: '/Videos/Quelle/spites.svg', data: 'spites', type: 'image/svg+xml' }
            ]);
        }
    },
    {
        environment: { path: '/', files: FILESYSTEMS[1] },
        html: 'Erstelle im Wurzelordner eine Datei mit dem Namen <code>∞🙉 ↑</code>.',
        onchange() {
            var file = this._root.getByPath('/∞🙉 ↑');
            return (file && !file.isDir);
        }
    },
    {
        environment: { path: '/', files: FILESYSTEMS[4] },
        html: 'Lösche nun die Datei <code>∞🙉 ↑</code> wieder.',
        onchange() {
            return !this.check([
                { path: '/', contains: 4 },
                { path: '/trailer3.mp4', data: 'trailer3', type: 'video/mp4' },
                { path: '/Arbeitsauftrag.pdf', data: 'Arbeitsauftrag', type: 'application/pdf' },
                { path: '/Fotos/foto01.jpg', data: 'foto01', type: 'image/jpeg' },
                { path: '/Fotos/foto02.jpg', data: 'foto02', type: 'image/jpeg' },
                { path: '/Fotos/foto03.jpg', data: 'foto03', type: 'image/jpeg' },
                { path: '/Fotos/foto04.jpg', data: 'foto04', type: 'image/jpeg' },
                { path: '/Fotos/foto05.jpg', data: 'foto05', type: 'image/jpeg' },
                { path: '/Fotos/foto06.jpg', data: 'foto06', type: 'image/jpeg' },
                { path: '/Fotos/foto07.jpg', data: 'foto07', type: 'image/jpeg' },
                { path: '/Fotos/foto08.jpg', data: 'foto08', type: 'image/jpeg' },
                { path: '/Fotos/foto09.jpg', data: 'foto09', type: 'image/jpeg' },
                { path: '/Fotos/foto10.jpg', data: 'foto10', type: 'image/jpeg' },
                { path: '/Fotos/foto11.jpg', data: 'foto11', type: 'image/jpeg' },
                { path: '/Referat' }
            ]);
        }
    },
    {
        environment: { path: '/', files: FILESYSTEMS[1] },
        html: '<code>foto07.jpg</code> im Ordner <code>Fotos</code> brauchst du auch für dein Referat. Kopiere es also in den Ordner <code>Referat</code>.',
        onchange() {
            var file = this._root.getByPath('/Fotos/foto07.jpg');
            if (!file || (file.data != 'foto07'))
                return false;
            file = this._root.getByPath('/Referat/foto07.jpg');
            if (!file || (file.data != 'foto07'))
                return false;
            return true;
        }
    },
    {
        environment: { path: '/Referat', files: FILESYSTEMS[2], clipboard: { path: '/Fotos/foto07.jpg', move: false } },
        html: 'Bevor du mit dem Bearbeiten der Dateien deines Referats beginnst: Lege eine Sicherungskopie an, indem du alle Dateien im Ordner <code>/Referat</code> in den Unterordner <code>backup</code> kopierst.',
        onchange() {
            return !this.check([
                { path: '/Referat/Praesentation.odp', data: 'Praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
                { path: '/Referat/Handout.odt', data: 'Handout', type: 'application/vnd.oasis.opendocument.text' },
                { path: '/Referat/Handout.pdf', data: 'Handout', type: 'application/pdf' },
                { path: '/Referat/foto07.jpg', data: 'foto07', type: 'image/jpeg' },
                { path: '/Referat/backup/Praesentation.odp', data: 'Praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
                { path: '/Referat/backup/Handout.odt', data: 'Handout', type: 'application/vnd.oasis.opendocument.text' },
                { path: '/Referat/backup/Handout.pdf', data: 'Handout', type: 'application/pdf' },
                { path: '/Referat/backup/foto07.jpg', data: 'foto07', type: 'image/jpeg' }
            ]);
        }
    },
    {
        environment: { path: '/Referat', files: FILESYSTEMS[3] },
        html: 'Nach dem Bearbeiten aller Dateien für dein Referat stellst du fest, dass die Bildschirmpräsentation schlechter geworden ist. Kein Problem, dafür hast du ja eine Sicherungskopie angelegt! Stelle die Sicherungskopie nur von <code>Praesentation.odp</code> wieder her, indem du sie durch die Sicherungskopie im Ordner <code>backup</code> ersetzt.',
        onchange() {
            return !this.check([
                { path: '/Referat/Praesentation.odp', data: 'backup/Praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
                { path: '/Referat/Handout.odt', data: 'Handout', type: 'application/vnd.oasis.opendocument.text' },
                { path: '/Referat/Handout.pdf', data: 'Handout', type: 'application/pdf' },
                { path: '/Referat/foto07.jpg', data: 'foto07', type: 'image/jpeg' },
                { path: '/Referat/backup/Praesentation.odp', data: 'backup/Praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
                { path: '/Referat/backup/Handout.odt', data: 'backup/Handout', type: 'application/vnd.oasis.opendocument.text' },
                { path: '/Referat/backup/Handout.pdf', data: 'backup/Handout', type: 'application/pdf' },
                { path: '/Referat/backup/foto07.jpg', data: 'backup/foto07', type: 'image/jpeg' }
            ]);
        }
    },
    {
        environment: { path: '/Referat', files: FILESYSTEMS[3] },
        html: 'Verschiebe die Datei <code>trailer3.mp4</code> vom Wurzelordner in den Ordner <code>Videos</code>.',
        onchange() {
            var file = this._root.getByPath('/Videos/trailer3.mp4');
            if (!file || (file.data != 'trailer3'))
                return false;
            function checkDir(obj) {
                for (var z = 0; z < obj.data.length; ++z) {
                    if (obj.data[z].isDir && !checkDir(obj.data[z]))
                        return false;
                    if ((obj.data[z].data == 'trailer3') && (obj.data[z].getPath() != '/Videos/trailer3.mp4'))
                        return false;
                }
                return true;
            }
            return checkDir(this._root);
        }
    },
    {
        environment: { path: '/', files: FILESYSTEMS[5] },
        html: 'Erstelle eine Videodatei mit dem Pfad <code>/Videos/→←/🙈🙉🙊/😂.mp4</code>.',
        onchange() {
            var file = this._root.getByPath('/Videos/→←/🙈🙉🙊/😂.mp4');
            return (file && !file.isDir && file.type && (file.type.substr(0, 6) == 'video/'));
        }
    }
];

window.FILESYSTEMSETTINGS = {
    useClipboard: true,
    levels: LEVELS
};
